;Owner-menu style 2 - by coder7345[@gmx.net]
;Bibliography: Menu-WebLink by entro-p [entro-p@asmz.com]
.386
.model flat, stdcall
option casemap :none

include \masm32\include\windows.inc

incboth MACRO xincl
	include \masm32\include\xincl.inc
	includelib \masm32\lib\xincl.lib
ENDM

incboth kernel32
incboth user32
incboth gdi32
incboth shell32

.const
	IDD_MAINDIALOG		EQU	101
	IDM_ABOUT			EQU	101
	IDM_WEBLINK			EQU	102
	IDM_QUIT			EQU	103
	
	IDC_CURSOR			EQU	1001
	
	IDI_WORLDOFF		EQU	101
	IDI_WORLDON			EQU	102

.data?
	hInstance			HINSTANCE	?
	hCursor			HANDLE	?
	hIconWorldOff		HANDLE	?
	hIconWorldOn		HANDLE	?
	hMenu				HANDLE	?
	Buff				BYTE 100 dup(?)
.code

DlgProc		PROTO	hWnd:HWND, uMsg:DWORD, wParam:DWORD, lParam:DWORD

start:
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	
	invoke DialogBoxParam, hInstance, IDD_MAINDIALOG, NULL, addr DlgProc, NULL

	invoke ExitProcess, NULL
	
;-------------------------------------------------------------------------------
.data
	szwin32asm			db				"http://win32asm.cjb.net",0
	szAboutCaption		db				"Menu Weblink",0
	szAboutText			db				"(c) Entro-P Jan 2000",13,10
						db				"mail: entro-p@asmz.com",13,10,13,10
						db				"This is not meant as an optimized example,",13,10
						db				"but merely a clear example on _how_ it is done!",0
;-------------------------------------------------------------------------------

sSIZE	struct
	px		DWORD		?
	py		DWORD		?
sSIZE	ends

.code
DlgProc		PROC	hWnd:HWND, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	local	mii				:MENUITEMINFO
	local	r				:RECT
	local	lFont				:LOGFONT
	local	s				:sSIZE
	local	cxBitmap			:DWORD
	local	cyBitmap			:DWORD
	local	cyBitmapAdd			:DWORD
	local rc				:RECT

	.IF uMsg == WM_INITDIALOG
		invoke LoadIcon, hInstance, 1
		invoke SendMessage, hWnd, WM_SETICON, ICON_BIG, eax
		
		invoke LoadCursor, hInstance, IDC_CURSOR
		mov hCursor, eax
		invoke LoadIcon, hInstance, IDI_WORLDOFF
		mov hIconWorldOff, eax
		invoke LoadIcon, hInstance, IDI_WORLDON
		mov hIconWorldOn, eax
		
		invoke GetMenu, hWnd
		mov hMenu,eax
		invoke GetSubMenu, eax, 0
		mov hMenu, eax
			push ecx
		mov ecx,105
		@@:
		mov mii.cbSize, SIZEOF mii
		mov mii.fMask, MIIM_TYPE 		
		push ecx
		invoke GetMenuItemInfo, hMenu, ecx, FALSE, addr mii
		pop ecx
		or mii.fType, MFT_OWNERDRAW
		push ecx
		invoke SetMenuItemInfo, hMenu, ecx, FALSE, addr mii
		pop ecx
		dec ecx
		cmp ecx,101
		jne @B
			pop ecx
	.ELSEIF uMsg == WM_COMMAND
		mov eax, wParam
		shr eax, 16
		.IF eax == BN_CLICKED
			mov eax, wParam
			and eax, 0FFFFh
			.IF eax == IDM_ABOUT
				invoke MessageBox, hWnd, addr szAboutText, addr szAboutCaption, MB_ICONINFORMATION + MB_OK
			.ELSEIF eax == IDM_WEBLINK
				invoke LoadCursor, NULL, IDC_WAIT
				invoke SetCursor, eax
				invoke ShellExecute, NULL, NULL, addr szwin32asm, NULL, NULL, NULL
			.ELSEIF eax == IDM_QUIT
				invoke SendMessage, hWnd, WM_CLOSE, NULL, NULL
			.ENDIF
		.ENDIF
	.ELSEIF uMsg == WM_MEASUREITEM
		.IF ! wParam ; menu
			push edi
			mov edi, lParam
			assume edi: ptr MEASUREITEMSTRUCT
			mov [edi].itemHeight, 22
			invoke GetMenuString,hMenu,[edi].itemID,addr Buff,100,TRUE
			invoke lstrlen,addr Buff
			mov esi,eax
			invoke GetWindowDC, hWnd
			push ebx
			mov ebx, eax
			invoke GetTextExtentPoint32, ebx, addr Buff, esi, addr s
			mov ebx, eax
			mov eax, s.px
			add eax, 22
			pop ebx
			mov [edi].itemWidth, eax
			assume edi: nothing
			pop edi
		.ENDIF	
	.ELSEIF uMsg == WM_DRAWITEM
		.IF ! wParam ; menu
			push edi
			mov edi, lParam
			assume edi: ptr DRAWITEMSTRUCT
			mov eax, [edi].itemAction
			push eax
			and eax, ODA_DRAWENTIRE
			mov eax, TRUE
			.IF eax ; must draw entire rect
				invoke DrawEdge, [edi].hdc, addr [edi].rcItem , NULL, BF_MIDDLE
				pop eax
				or eax, ODA_SELECT    ; force text redraw
				push eax
			.ENDIF

			pop eax
			and eax, ODA_SELECT
			.IF eax	; selection changed
				mov eax, [edi].itemState
				and eax, ODS_SELECTED	
				.IF eax	; selected
;					invoke	GetSysColor,COLOR_HIGHLIGHT
;					invoke	CreateSolidBrush,eax
;					mov esi,eax
;					add [edi].rcItem.left,22
;					invoke FillRect,[edi].hdc,addr [edi].rcItem,esi
;					sub [edi].rcItem.left,22
					add [edi].rcItem.left,3
					add [edi].rcItem.top, 3
					invoke DrawIconEx, [edi].hdc, [edi].rcItem.left, [edi].rcItem.top, hIconWorldOff, 16, 16, NULL, NULL, DI_NORMAL
					sub [edi].rcItem.top, 3
					sub [edi].rcItem.left,3
					invoke SetBkMode, [edi].hdc, TRANSPARENT
;					invoke GetSysColor,COLOR_HIGHLIGHTTEXT
;					invoke SetTextColor, [edi].hdc, eax
					invoke GetSysColor, COLOR_WINDOWTEXT
					invoke SetTextColor, [edi].hdc, eax
;-------------------------------------------------------------------------------------------------------
;					push [edi].rcItem.right
;					mov [edi].rcItem.right,23
;					invoke DrawEdge,[edi].hdc,addr [edi].rcItem,BDR_RAISEDINNER,BF_RECT
;					pop [edi].rcItem.right
					invoke DrawEdge,[edi].hdc,addr [edi].rcItem,EDGE_ETCHED,BF_RECT
				.ELSE 	; not selected
					add [edi].rcItem.left,3
					add [edi].rcItem.top, 3
					invoke DrawIconEx, [edi].hdc, [edi].rcItem.left, [edi].rcItem.top, hIconWorldOff, 16, 16, NULL, NULL, DI_NORMAL
					sub [edi].rcItem.top,3
					sub [edi].rcItem.left,3
					invoke GetSysColor, COLOR_WINDOWTEXT
					invoke SetTextColor, [edi].hdc, eax
				.ENDIF
				push [edi].rcItem.left
				add [edi].rcItem.left,26 ;eax ; add button width
				invoke GetMenuString,hMenu,[edi].itemID,addr Buff,100,TRUE
				invoke lstrlen,addr Buff
				mov esi,eax
				invoke DrawText, [edi].hdc, addr Buff, esi, addr [edi].rcItem, DT_VCENTER + DT_SINGLELINE
				pop [edi].rcItem.left
			.ENDIF	
			assume edi: nothing
			pop edi
		.ENDIF	
	.ELSEIF uMsg == WM_CLOSE
			invoke EndDialog, hWnd, NULL
	.ELSE
		xor eax, eax
		ret
	.ENDIF
	mov eax, TRUE
	ret
DlgProc		ENDP	

;-------------------------------------------------------------------------------

end start